// defining all constants for pins connected according to the set-up - inputs and output

const int MotorControlPin1 = 2;
const int MotorControlPin2 = 3;
const int MotorEnablePin = 9;
const int SwitchDirectionPin = 5;
const int SwitchOnOffPin = 4;
const int PotentiometerPin = A0;

// defining some variables for inputs (switches)

int SwitchOnOffState = 0;
int PreviousSwitchOnOffState = 0;
int SwitchDirectionState = 0;
int PreviousSwitchDirectionState = 0;

// defining some variables for output (motor)

int MotorEnabled = 0;
int MotorSpeed = 0;
int MotorDirection = 1;

// defining inouts and outputs (setup code, runs once)

void setup() {
pinMode(SwitchDirectionPin, INPUT);
pinMode(SwitchOnOffPin, INPUT);
pinMode(MotorControlPin1, OUTPUT);
pinMode(MotorControlPin2, OUTPUT);
pinMode(MotorEnablePin, OUTPUT);
digitalWrite(MotorEnablePin, LOW);
}

// the loop

void loop() {
SwitchOnOffState = digitalRead(SwitchOnOffPin);
delay(1);
SwitchDirectionState = digitalRead(SwitchDirectionPin);
MotorSpeed = analogRead(PotentiometerPin)/4;

// to check if on/off status has changed from previous state

if(SwitchOnOffState != PreviousSwitchOnOffState){
  if(SwitchOnOffState == HIGH){
    MotorEnabled = !MotorEnabled;
  }
}

// to check if dorection has changed from previous state

if(SwitchDirectionState != PreviousSwitchDirectionState){
  if(SwitchDirectionState == HIGH){
    MotorDirection = !MotorDirection;
  }
}

// to change direction

if (MotorDirection == 1) {
  digitalWrite(MotorControlPin1, HIGH);
  digitalWrite(MotorControlPin2, LOW);
}
else {
  digitalWrite(MotorControlPin1, LOW);
  digitalWrite(MotorControlPin2, HIGH);
}

// set the speed

if (MotorEnabled == 1){
  analogWrite(MotorEnablePin, MotorSpeed);
}
else {
  analogWrite(MotorEnablePin, 0);
}

PreviousSwitchDirectionState = SwitchDirectionState;
PreviousSwitchOnOffState = SwitchOnOffState;

}
